#include <vector>
#include <cassert>

int sum(const std::vector<int>& v) {
    int ret = 0;
    for (std::vector<int>::const_iterator i = v.begin(); i != v.end(); ++i)
        ret += *i;
    return ret;
}

int sum_tail_aux(const std::vector<int>::const_iterator end, std::vector<int>::const_iterator i, int acc) {
    if (i == end) return acc;
    int t = *i;
    return sum_tail_aux(end, ++i, t + acc);
}

int sum_tail(const std::vector<int>& v) {
    return sum_tail_aux(v.end(), v.begin(), 0);
}

int main() {
    int buf[] = { 1, 2, 3, 4, 5, 1000 };
    const int n = sizeof(buf) / sizeof(buf[0]);
    std::vector<int> v(buf, buf+n);
    assert(sum(v) == sum_tail(v));
}
